package nc.ui.gl.assattributebanlance;

import java.awt.Insets;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.lang.reflect.Constructor;
import java.util.Hashtable;
import javax.swing.DefaultCellEditor;
import javax.swing.JFrame;
import nc.ui.bd.b02.BdinfoBO_Client;
import nc.ui.bd.def.DefaultDefdocRefModel;
import nc.ui.bd.ref.AbstractRefModel;
import nc.ui.glcom.ass.AssRefPanel;
import nc.ui.glcom.ass.RefModel;
import nc.ui.glcom.control.GlComboBox;
import nc.ui.ml.NCLangRes;
import nc.ui.pub.ClientEnvironment;
import nc.ui.pub.beans.UIComboBox;
import nc.ui.pub.beans.UITablePane;
import nc.ui.pub.beans.table.VOTableModel;
import nc.vo.bd.b02.BdinfoVO;
import nc.vo.glcom.ass.AssVO;
import nc.vo.glcom.balance.GLQueryObj;
import nc.vo.pub.ValueObject;

public class QryObjectList extends UITablePane {

   private QryObjectList.QryObjectListTableModel m_tableModel = null;
   private UIComboBox ivjCBDisPosition = null;
   private Hashtable hashTblRefValues = new Hashtable();
   private GlComboBox ivjGLCBQryObject = null;
   private ClientEnvironment env = null;
   private BdinfoVO[] refData1 = null;
   private String[] showName = null;
   private String pk_corp = null;


   public QryObjectList() {
      this.initialize();
   }

   public QryObjectList(int vsbPolicy, int hsbPolicy) {
      super(vsbPolicy, hsbPolicy);
   }

   public void fireStopEditing() {
      for(int j = 0; j < 10; ++j) {
         for(int i = 0; i < 3; ++i) {
            this.getTable().getCellEditor(j, i).stopCellEditing();
         }
      }

   }

   private UIComboBox getCBDisPosition() {
      if(this.ivjCBDisPosition == null) {
         try {
            this.ivjCBDisPosition = new UIComboBox();
            this.ivjCBDisPosition.setName("CBDisPosition");
            this.ivjCBDisPosition.setLocation(26, 467);
            this.ivjCBDisPosition.addItem(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000197"));
            this.ivjCBDisPosition.addItem(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000192"));
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjCBDisPosition;
   }

   private GlComboBox getGLCBQryObject() {
      if(this.ivjGLCBQryObject == null) {
         try {
            this.ivjGLCBQryObject = new GlComboBox();
            this.ivjGLCBQryObject.setName("GLCBQryObject");
            this.ivjGLCBQryObject.setLocation(187, 464);
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjGLCBQryObject;
   }

   public String getPk_corp() {
      if(this.pk_corp == null) {
         this.pk_corp = this.env != null?this.env.getCorporation().getPk_corp():ClientEnvironment.getInstance().getCorporation().getPk_corp();
      }

      return this.pk_corp;
   }

   public QryObjectList.QryObjectListTableModel getTableModel() {
      if(this.m_tableModel == null) {
         try {
            GLQueryObj[] e = new GLQueryObj[10];

            for(int i = 0; i < 10; ++i) {
               e[i] = new GLQueryObj();
            }

            this.m_tableModel = new QryObjectList.QryObjectListTableModel(e);
            this.m_tableModel.setQuryObjVOs(e);
         } catch (Exception var3) {
            var3.printStackTrace();
         }
      }

      return this.m_tableModel;
   }

   private void handleException(Throwable exception) {
   }

   private void initData(String sCorp) {
      try {
         this.getGLCBQryObject().removeAllItems();
         this.getGLCBQryObject().addItem("", (Object)null);
         this.getGLCBQryObject().addItem(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031"), (Object)null);
         this.refData1 = BdinfoBO_Client.queryAll(sCorp, "");
         if(this.refData1 != null && this.refData1.length != 0) {
            this.showName = new String[this.refData1.length];

            for(int e = 0; e < this.showName.length; ++e) {
               this.showName[e] = this.refData1[e].getBdname();
               this.getGLCBQryObject().addItem(this.showName[e], this.refData1[e]);
            }
         }
      } catch (Exception var3) {
         var3.printStackTrace();
      }

   }

   private void initialize() {
      try {
         this.setName("QryObjectList");
         this.setSize(453, 403);
      } catch (Throwable var3) {
         this.handleException(var3);
      }

      this.getTable().setModel(this.getTableModel());
      this.getTable().setCellSelectionEnabled(true);
      this.getTable().setAutoResizeMode(0);
      DefaultCellEditor positionEditer = new DefaultCellEditor(this.getCBDisPosition());
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000231")).setCellEditor(positionEditer);
      DefaultCellEditor qryObjEditer = new DefaultCellEditor(this.getGLCBQryObject());
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000140")).setCellEditor(qryObjEditer);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000140")).setPreferredWidth(70);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000140")).setWidth(70);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setPreferredWidth(200);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setWidth(200);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000231")).setPreferredWidth(55);
      this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000231")).setWidth(55);
      this.initData(this.getPk_corp());
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         QryObjectList aQryObjectList = new QryObjectList();
         exception.setContentPane(aQryObjectList);
         exception.setSize(aQryObjectList.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.gl.assattributebanlance.QryObjectList 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   public void setPk_corp(String newPk_corp) {
      this.pk_corp = newPk_corp;
   }

   private void setValueRef(int row) {
      try {
         GLQueryObj[] ex = this.getTableModel().getQuryObjVOs();
         boolean i = false;

         int var16;
         for(var16 = 0; var16 < this.refData1.length && !ex[row].getType().equals(this.refData1[var16].getBdname()); ++var16) {
            ;
         }

         BdinfoVO bdinfoVO = this.refData1[var16];
         String strNodeName = bdinfoVO.getRefnodename();
         String strBdInfo = bdinfoVO.getPk_bdinfo();
         String strBdName = bdinfoVO.getBdname();
         AssRefPanel assrefTemp = new AssRefPanel(strBdInfo, this.pk_corp);
         if(!this.hashTblRefValues.containsKey(strBdName)) {
            if(strNodeName != null && !strNodeName.trim().equals("")) {
               assrefTemp.setRefNodeName(strNodeName);
               assrefTemp.getRefModel().setRefNodeName(strNodeName, this.pk_corp);
               String var19 = assrefTemp.getRefModel().getWherePart();
               if(bdinfoVO.getBdcode().startsWith("J")) {
                  assrefTemp.getRef().setRefType(0);
                  if(var19 != null && !var19.trim().equals("")) {
                     var19 = var19 + " and bd_jobtype.pk_jobtype = \'" + bdinfoVO.getPk_defdef() + "\'";
                  } else {
                     var19 = " bd_jobtype.pk_jobtype = \'" + bdinfoVO.getPk_defdef() + "\'";
                  }
               }

               assrefTemp.getRefModel().setWherePart(var19);
               assrefTemp.setMultiSelectedEnabled(true);
            } else if(bdinfoVO.getSelfrefclass() != null) {
               if(bdinfoVO.getIsdef().booleanValue()) {
                  DefaultDefdocRefModel model = (DefaultDefdocRefModel)Class.forName(bdinfoVO.getSelfrefclass()).newInstance();
                  model.setPkdefdef(bdinfoVO.getPk_defdef());
                  assrefTemp.setIsCustomDefined(true);
                  assrefTemp.setRefModel(model);
                  assrefTemp.setMultiSelectedEnabled(true);
               } else {
                  Class classTemp = Class.forName(bdinfoVO.getSelfrefclass());

                  try {
                     Constructor ee = null;

                     AbstractRefModel var17;
                     try {
                        ee = classTemp.getConstructor(new Class[]{String.class});
                        var17 = (AbstractRefModel)ee.newInstance(new Object[]{ClientEnvironment.getInstance().getCorporation().getPk_corp()});
                     } catch (NoSuchMethodException var13) {
                        var17 = (AbstractRefModel)classTemp.newInstance();
                     }

                     assrefTemp.setIsCustomDefined(true);
                     assrefTemp.setRefModel(var17);
                     assrefTemp.setMultiSelectedEnabled(true);
                  } catch (Exception var14) {
                     var14.printStackTrace();
                  }
               }
            } else {
               RefModel var18 = new RefModel();
               var18.setDefaultFieldCount(2);
               var18.setTableName(bdinfoVO.getBdname());
               var18.setBlurFields(new String[]{bdinfoVO.getCodefieldname()});
               var18.setFieldCode(new String[]{bdinfoVO.getCodefieldname(), bdinfoVO.getNamefieldname()});
               var18.setHiddenFieldCode(new String[]{bdinfoVO.getTablepkname()});
               var18.setTableName(bdinfoVO.getTablename());
               var18.setPkFieldCode(bdinfoVO.getTablepkname());
               if(bdinfoVO.getCorpfieldname() != null) {
                  var18.setWherePart(bdinfoVO.getCorpfieldname() + " =\'\'");
               }

               assrefTemp.setRefModel(var18);
               assrefTemp.setIsCustomDefined(true);
               assrefTemp.setMultiSelectedEnabled(true);
            }

            this.hashTblRefValues.put(strBdName, assrefTemp);
            this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setCellEditor(assrefTemp);
         } else {
            this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setCellEditor((AssRefPanel)this.hashTblRefValues.get(strBdName));
         }
      } catch (Exception var15) {
         var15.printStackTrace();
      }

   }

   public class QryObjectListTableModel extends VOTableModel {

      String[] ColumnName = new String[]{NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000140"), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230"), NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000231")};
      private GLQueryObj[] m_vos = null;
      private Hashtable hashTblRefValues = new Hashtable();


      public QryObjectListTableModel(ValueObject[] vos) {
         super(vos);
      }

      public QryObjectListTableModel(Class c) {
         super(c);
      }

      public QryObjectListTableModel(ValueObject vo) {
         super(vo);
      }

      public Class getColumnClass(int col) {
         return String.class;
      }

      public int getColumnCount() {
         return 3;
      }

      public String getColumnName(int col) {
         return this.ColumnName[col];
      }

      public GLQueryObj[] getQuryObjVOs() {
         return this.m_vos;
      }

      public int getRowCount() {
         return 10;
      }

      public Object getValueAt(int row, int col) {
         GLQueryObj tempVO = (GLQueryObj)this.getVO(row);
         switch(col) {
         case 0:
            return tempVO.getType();
         case 1:
            if(tempVO.getValueRange() == null) {
               return tempVO.getValueRange();
            }

            AssVO[] aAssVo = (AssVO[])tempVO.getValueRange();
            String strNames = "";

            for(int i = 0; i < aAssVo.length; ++i) {
               strNames = strNames + "," + aAssVo[i].getCheckvaluename();
            }

            return strNames.length() == 0?"":strNames.substring(1, strNames.length());
         case 2:
            if(tempVO.getHeadEle()) {
               return NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000197");
            }

            return NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000192");
         default:
            return null;
         }
      }

      public boolean isCellEditable(int row, int col) {
         if(col != 0 && (this.getValueAt(row, 0) == null || this.getValueAt(row, 0).equals(""))) {
            return false;
         } else if(col == 0) {
            return true;
         } else if(col == 1) {
            if(this.getValueAt(row, 0).equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031"))) {
               if(!this.hashTblRefValues.containsKey(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031"))) {
                  AssRefPanel assRefTmp = new AssRefPanel();
                  assRefTmp.setRefNodeName("会计科目");
                  assRefTmp.getRefModel().setRefNodeName("会计科目", QryObjectList.this.pk_corp);
                  assRefTmp.getRefModel().addWherePart(" or (sealflag is not null and bd_accsubj.pk_corp=\'" + QryObjectList.this.getPk_corp() + "\') ");
                  assRefTmp.setMultiSelectedEnabled(true);
                  this.hashTblRefValues.put(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031"), assRefTmp);
                  QryObjectList.this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setCellEditor(assRefTmp);
               } else {
                  QryObjectList.this.getTable().getColumn(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000230")).setCellEditor((AssRefPanel)this.hashTblRefValues.get(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031")));
               }
            } else {
               QryObjectList.this.setValueRef(row);
            }

            return true;
         } else {
            return true;
         }
      }

      public void setQuryObjVOs(GLQueryObj[] vos) throws Exception {
         this.clearTable();
         this.addVO(vos);
         this.m_vos = vos;
      }

      public void setValueAt(Object value, int r, int c) {
         switch(c) {
         case 0:
            if(value == null) {
               return;
            }

            this.getQuryObjVOs()[r].setType(value.toString());
            this.getQuryObjVOs()[r].setValueRange((AssVO[])null);
            break;
         case 1:
            AssVO[] aAssVosTemp = (AssVO[])((AssVO[])value);
            if(value != null && aAssVosTemp.length != 0) {
               aAssVosTemp = (AssVO[])((AssVO[])value);
            } else {
               aAssVosTemp = new AssVO[]{new AssVO()};
            }

            if(this.getQuryObjVOs()[r].getType() != null && !this.getQuryObjVOs()[r].getType().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000031"))) {
               int iIndex;
               for(iIndex = 0; iIndex < QryObjectList.this.refData1.length && !this.getQuryObjVOs()[r].getType().equals(QryObjectList.this.refData1[iIndex].getBdname()); ++iIndex) {
                  ;
               }

               for(int i = 0; i < aAssVosTemp.length; ++i) {
                  aAssVosTemp[i].setChecktypename(QryObjectList.this.refData1[iIndex].getBdname());
                  aAssVosTemp[i].setPk_Checktype(QryObjectList.this.refData1[iIndex].getPk_bdinfo());
                  aAssVosTemp[i].setChecktypecode(QryObjectList.this.refData1[iIndex].getBdcode());
               }
            }

            this.getQuryObjVOs()[r].setValueRange(aAssVosTemp);
            break;
         case 2:
            if(value.toString().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000197"))) {
               this.getQuryObjVOs()[r].setHeadEle(true);
            } else if(value.toString().equals(NCLangRes.getInstance().getStrByID("20023030", "UPP20023030-000192"))) {
               this.getQuryObjVOs()[r].setHeadEle(false);
            }
         }

      }
   }
}
